# -*- coding: utf-8 -*-
from setuphelpers import *
import time

# Installation procedure: https://www.sumatrapdfreader.org/docs/Installer-cmd-line-arguments.html
# Defining variables
##silent_args = '-s -d "%s"' % makepath(programfiles,'SumatraPDF')
app_uninstallkey = "SumatraPDF"


def install():
    # Initializing variablesS
    package_version = control.get_software_version()
    bin_name = "SumatraPDF-%s-64-install.exe" % package_version
    app_name = control.name

    # Uninstalling older versions
    for uninstall in installed_softwares(uninstallkey=app_uninstallkey):
        if Version(uninstall["version"]) < Version(package_version):
            print("Older %s version found (%s)" % (app_name, uninstall["version"]))
            print("Removing: %s" % uninstall["name"])
            killalltasks(control.impacted_process)
            run(uninstall_cmd(uninstall["key"]))
            wait_uninstallkey_absent(uninstall["key"])
            if isdir(makepath(programfiles, "SumatraPDF")):
                remove_tree(makepath(programfiles, "SumatraPDF"))
            time.sleep = 60

    # Installing the package
    install_exe_if_needed(
        bin_name,
        silentflags="-s -all-users",
        key=app_uninstallkey,
        min_version=package_version,
    )
