# -*- coding: utf-8 -*-
from setuphelpers import *
import bs4 as BeautifulSoup
import requests
import platform


# Installation procedure: https://www.sumatrapdfreader.org/docs/Installer-cmd-line-arguments.html

# Defining variables
bin_name_string = "SumatraPDF-%s-64-install.exe"


def update_package():
    print("Download/Update package content from upstream binary sources")

    # Getting proxy informations from WAPT settings
    proxy = {}
    if platform.system() == "Windows" and isfile(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini")):
        proxywapt = inifile_readstring(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini"), "global", "http_proxy")
        if proxywapt:
            proxy = {"http": proxywapt, "https": proxywapt}

    # Initializing variables
    app_name = control.name
    url = control.sources
    bin_end = bin_name_string.split("%s")[-1]

    # Getting latest version from official website
    page = requests.get(url, proxies=proxy, headers={"User-Agent": "Mozilla/5.0 (Windows NT 6.1; Win64; x64)"}).text
    bs = BeautifulSoup.BeautifulSoup(page)
    bs_read = bs.findAll("a", {"onclick": "return SetupRedirect()"})
    for link in bs_read:
        if link["href"].endswith(bin_end):
            # https://www.sumatrapdfreader.org/dl2/SumatraPDF-3.2-64-install.exe
            url_dl = "https://www.sumatrapdfreader.org" + link["href"]

    latest_bin = url_dl.split("/")[-1]
    version = latest_bin.split("-")[1]

    print("Latest %s version is: %s" % (app_name, version))
    print("Download url is: %s" % url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(url_dl, latest_bin, proxies=proxy)

        # Checking version from file
        version_from_file = get_file_properties(latest_bin)["ProductVersion"]
        if version != version_from_file and version_from_file != "":
            version = version_from_file
            old_latest_bin = latest_bin
            latest_bin = bin_name_string % version
            if isfile(latest_bin):
                remove_file(latest_bin)
            os.rename(old_latest_bin, latest_bin)
            print("Verified latest " + app_name + " version is: " + version)

        # Changing version of the package
        control.version = "%s-%s" % (version, int(control.version.split("-")[-1]) + 1)
        control.save_control_to_wapt()
        print("Changing version to: %s in WAPT\\control" % control.version)

    # Deleting outdated binaries
    for bin_in_dir in glob.glob("*.exe") or glob.glob("*.msi"):
        if bin_in_dir != latest_bin:
            print("Outdated binary: " + bin_in_dir + " Deleted")
            remove_file(bin_in_dir)
